VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin MSComDlg.CommonDialog dlg 
      Left            =   2340
      Top             =   1980
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Monoton_DS - Simple Stream

Implements IDSOutCallback

Private clsMonoLoader   As Monoton_DS.MonotonLoader
Private clsOutput       As Monoton_DS.SoundOut
Private clsStream       As Monoton_DS.ISoundStream
Private clsTag          As Monoton_DS.StreamTag

Private Sub Form_Load()
    Dim i   As Long

    Set clsMonoLoader = New Monoton_DS.MonotonLoader

    Debug.Print "=== Devices     ============"
    For i = 1 To clsMonoLoader.DeviceCount
        Debug.Print clsMonoLoader.DeviceDescription(i)
    Next
    Debug.Print ""

    If Not clsMonoLoader.Initialize(44100, 2, 16) Then
        MsgBox "Could not init Monoton!", vbExclamation
        Unload Me
    End If

    Set clsOutput = clsMonoLoader.CreateSoundOut()
    Set clsStream = New Monoton_DS.StreamMP3

    dlg.FileName = vbNullString
    dlg.Filter = Join(clsStream.Extensions, "; ") & "|*." & Join(clsStream.Extensions, ";*.")
    dlg.ShowOpen
    If dlg.FileName = vbNullString Then
        Unload Me
        Exit Sub
    End If

    If clsStream.OpenSource(dlg.FileName) <> STREAM_OK Then
        MsgBox "Could not open source!", vbExclamation
        Unload Me
        Exit Sub
    End If

    If Not clsOutput.Initialize(clsStream, Me) Then
        MsgBox "Could not init output!", vbExclamation
        Unload Me
    End If

    With clsOutput
        Debug.Print "=== Stream Info ============"
        Debug.Print "Samplerate: ", .StreamInfo.samplerate
        Debug.Print "Channels: ", .StreamInfo.channels
        Debug.Print "Bits/Sample: ", .StreamInfo.bitspersample
        Debug.Print "Bitrate: ", (.StreamInfo.Bitrate / 1000) & " kBit/s"
        Debug.Print "Duration: ", FmtTime(.StreamInfo.Duration / 1000) & " min"
        Debug.Print ""
    End With

    Debug.Print "=== Tags        ============"
    For Each clsTag In clsStream.Info.Tags
        With clsTag
            Debug.Print .TagName, .TagValue
        End With
    Next

    clsOutput.Volume = 100
    clsOutput.Pan = 0

    If Not clsOutput.Play() Then
        MsgBox "Could not play stream!", vbExclamation
        Unload Me
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    clsOutput.StopPlay
End Sub

Private Sub IDSOutCallback_OnEndOfStream( _
    sndout As SoundOut _
)

    MsgBox "End Of Stream!", vbInformation
    Unload Me
End Sub

Private Sub IDSOutCallback_OnStatusChanged( _
    sndout As SoundOut, _
    ByVal udeStat As Monoton_DS.DS_PlayState _
)

    Debug.Print "Status: ";
    Select Case udeStat
        Case STAT_PAUSING: Debug.Print "Pause"
        Case STAT_PLAYING: Debug.Print "Play"
        Case STAT_STOPPED: Debug.Print "Stop"
    End Select
End Sub

Private Sub IDSOutCallback_Samples( _
    sndout As SoundOut, _
    intSamples() As Integer, _
    ByVal datalength As Long, _
    ByVal channels As Integer _
)

    '
End Sub

Private Function FmtTime( _
    ByVal seconds As Long _
) As String

    Dim minutes     As Long

    minutes = seconds \ 60
    seconds = seconds Mod 60

    FmtTime = minutes & ":" & Format(seconds, "00")
End Function
